#!/usr/bin/perl -w
# This file is part of the "FDN tools" project.
# You can use and redistribute it under the terms of the
# GNU General Public License.
# (c) French Data Network 1997-2005
# Authors and contributors:
# - Alexis Sukrieh
# - Benjamin Bayart

use strict;
use Sitalibs::Plutar::API;
use Sitalibs::Common::Constantes;
use Sitalibs::DBC::Net7 qw ( $dbh ) ;

my $g_choice;
my $g_action;
my $g_dtdo;
sub print_menu();
sub read_choice();
sub exec_choice();
sub lister_taches($);
sub ajouter_tache();

while (TRUE) {
	print_menu();
	read_choice();
	exec_choice();
}


sub print_menu()
{
	system ('clear');
	print <<EOF;
-----------------------------------------------------------------------------
P L U T A R    s h e l l

1 - lister les tches en attente de traitement
2 - lister les tche choues
3 - ajouter une tche
4 - sortie
-----------------------------------------------------------------------------
EOF
	print "> ";
}

sub read_choice()
{
	$g_choice = <STDIN>;
	chomp ($g_choice);
}

sub exec_choice()
{
	if ($g_choice == 1) {
		lister_taches('waiting');
	}
	elsif ($g_choice == 2) {
		lister_taches('failed');
	}
	elsif ($g_choice == 3) {
		ajouter_tache();
	}
	elsif ($g_choice == 4) {
		exit();
	}
	else {
		print "action $g_choice inconnue\n";
	}

	print "\n[OK]";
	<STDIN>;
}


sub lister_taches ($)
{
	my $etat = shift;
	my $rh_ret = Sitalibs::Plutar::API::GetTaskList({ dbh => $dbh, etat => $etat});
	if ($rh_ret->{status}) {
		print "Tches dont l'etat est '$etat'\n";
		foreach my $rh_task (@{$rh_ret->{ra_task}}) {
			next if not defined ($rh_task->{PLUTAR_ID});
			print "Tache #".$rh_task->{PLUTAR_ID}.": "; 	# Tache #12: 
			print $rh_task->{PLUTAR_ACTION} . " -> " . $rh_task->{PLUTAR_DTDO};
			print "\n";
		}
	}
	else {
		print "erreur lors de la lecture des tches (".$rh_ret->{erreur}.")\n";
	}	
}

sub ajouter_tache ()
{
	print "action : ";
	my $g_action = <STDIN>;
	chomp($g_action);

	print "date   : ";
	my $g_dtdo = <STDIN>;
	chomp($g_dtdo);

	my $rh_task = Sitalibs::Plutar::API::SetNewTask ({
		dbh => 	$dbh,
		action => $g_action,
		dtdo => $g_dtdo
	});

	if ($rh_task->{status}) {
		print "tche cre \n";
	}
	else {
		print "impossible de crer la tche (".$rh_task->{erreur}.")\n";
	}
}
